// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcCleanQualityFieldNames          = builder.RawFieldNames(&DcCleanQuality{})
	dcCleanQualityRows                = strings.Join(dcCleanQualityFieldNames, ",")
	dcCleanQualityRowsExpectAutoSet   = strings.Join(stringx.Remove(dcCleanQualityFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcCleanQualityRowsWithPlaceHolder = strings.Join(stringx.Remove(dcCleanQualityFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcCleanQualityModel interface {
		Insert(ctx context.Context, data *DcCleanQuality) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcCleanQuality, error)
		FindOneByProjectIdTagItem(ctx context.Context, projectId int64, tag string, item string) (*DcCleanQuality, error)
		Update(ctx context.Context, data *DcCleanQuality) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcCleanQualityModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcCleanQuality struct {
		Id        int64     `db:"id"`
		ProjectId int64     `db:"project_id"`
		Tag       string    `db:"tag"`      // 清洗批次
		Item      string    `db:"item"`     // 点位名
		Describe  string    `db:"describe"` // 数据质量描述
		CTime     time.Time `db:"c_time"`
	}
)

func newDcCleanQualityModel(conn sqlx.SqlConn) *defaultDcCleanQualityModel {
	return &defaultDcCleanQualityModel{
		conn:  conn,
		table: "`dc_clean_quality`",
	}
}

func (m *defaultDcCleanQualityModel) withSession(session sqlx.Session) *defaultDcCleanQualityModel {
	return &defaultDcCleanQualityModel{
		conn:  sqlx.NewSqlConnFromSession(session),
		table: "`dc_clean_quality`",
	}
}

func (m *defaultDcCleanQualityModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcCleanQualityModel) FindOne(ctx context.Context, id int64) (*DcCleanQuality, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcCleanQualityRows, m.table)
	var resp DcCleanQuality
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcCleanQualityModel) FindOneByProjectIdTagItem(ctx context.Context, projectId int64, tag string, item string) (*DcCleanQuality, error) {
	var resp DcCleanQuality
	query := fmt.Sprintf("select %s from %s where `project_id` = ? and `tag` = ? and `item` = ? limit 1", dcCleanQualityRows, m.table)
	err := m.conn.QueryRowCtx(ctx, &resp, query, projectId, tag, item)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcCleanQualityModel) Insert(ctx context.Context, data *DcCleanQuality) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?)", m.table, dcCleanQualityRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.Tag, data.Item, data.Describe, data.CTime)
	return ret, err
}

func (m *defaultDcCleanQualityModel) Update(ctx context.Context, newData *DcCleanQuality) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcCleanQualityRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, newData.ProjectId, newData.Tag, newData.Item, newData.Describe, newData.CTime, newData.Id)
	return err
}

func (m *defaultDcCleanQualityModel) tableName() string {
	return m.table
}
