// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcEventListFieldNames          = builder.RawFieldNames(&DcEventList{})
	dcEventListRows                = strings.Join(dcEventListFieldNames, ",")
	dcEventListRowsExpectAutoSet   = strings.Join(stringx.Remove(dcEventListFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcEventListRowsWithPlaceHolder = strings.Join(stringx.Remove(dcEventListFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcEventListModel interface {
		Insert(ctx context.Context, data *DcEventList) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcEventList, error)
		Update(ctx context.Context, data *DcEventList) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcEventListModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcEventList struct {
		Id         int64     `db:"id"`
		ProjectId  int64     `db:"project_id"`
		DeviceCode string    `db:"device_code"`
		Name       string    `db:"name"` // 事件名称
		Item       string    `db:"item"`
		Val        string    `db:"val"`      // 事件发生时，点位的值
		OldVal     string    `db:"old_val"`  // 事件发生时, 旧的点位值
		Time       time.Time `db:"time"`     // 事件触发时间
		EventId    int64     `db:"event_id"` // 事件 ID dc_event_bind.id
		Title      string    `db:"title"`    // 事件标题
		Context    string    `db:"context"`  // 事件内容
		CTime      time.Time `db:"c_time"`
	}
)

func newDcEventListModel(conn sqlx.SqlConn) *defaultDcEventListModel {
	return &defaultDcEventListModel{
		conn:  conn,
		table: "`dc_event_list`",
	}
}

func (m *defaultDcEventListModel) withSession(session sqlx.Session) *defaultDcEventListModel {
	return &defaultDcEventListModel{
		conn:  sqlx.NewSqlConnFromSession(session),
		table: "`dc_event_list`",
	}
}

func (m *defaultDcEventListModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcEventListModel) FindOne(ctx context.Context, id int64) (*DcEventList, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcEventListRows, m.table)
	var resp DcEventList
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcEventListModel) Insert(ctx context.Context, data *DcEventList) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", m.table, dcEventListRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.Name, data.Item, data.Val, data.OldVal, data.Time, data.EventId, data.Title, data.Context, data.CTime)
	return ret, err
}

func (m *defaultDcEventListModel) Update(ctx context.Context, data *DcEventList) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcEventListRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.Name, data.Item, data.Val, data.OldVal, data.Time, data.EventId, data.Title, data.Context, data.CTime, data.Id)
	return err
}

func (m *defaultDcEventListModel) tableName() string {
	return m.table
}
